<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><title>Python: module Collatz</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body bgcolor="#f0f0f8">

<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="heading">
<tr bgcolor="#7799ee">
<td valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial">&nbsp;<br><big><big><strong>Collatz</strong></big></big></font></td
><td align=right valign=bottom
><font color="#ffffff" face="helvetica, arial"><a href=".">index</a><br><a href="file:/usr/collatz/Collatz.py">/usr/collatz/Collatz.py</a></font></td></tr></table>
    <p><tt>#&nbsp;----------<br>
#&nbsp;Regina&nbsp;Chen<br>
#&nbsp;rc43758<br>
#&nbsp;CS&nbsp;373:&nbsp;Fall&nbsp;2018<br>
#&nbsp;Collatz.py<br>
#&nbsp;----------</tt></p>
<p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#eeaa77">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Functions</strong></big></font></td></tr>
    
<tr><td bgcolor="#eeaa77"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><dl><dt><a name="-collatz_eval"><strong>collatz_eval</strong></a>(i: int, j: int) -&gt; int</dt><dd><tt>i&nbsp;the&nbsp;beginning&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
j&nbsp;the&nbsp;end&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
return&nbsp;the&nbsp;max&nbsp;cycle&nbsp;length&nbsp;of&nbsp;the&nbsp;range&nbsp;[i,&nbsp;j]<br>
Check&nbsp;input&nbsp;validity&nbsp;and&nbsp;swap&nbsp;if&nbsp;i&nbsp;&gt;&nbsp;j<br>
Use&nbsp;meta&nbsp;cache's&nbsp;precomputed&nbsp;values&nbsp;of&nbsp;intervals&nbsp;of&nbsp;1,000&nbsp;numbers<br>
Then,&nbsp;compute&nbsp;max&nbsp;from&nbsp;the&nbsp;leftover&nbsp;range</tt></dd></dl>
 <dl><dt><a name="-collatz_print"><strong>collatz_print</strong></a>(writer: IO[str], i: int, j: int, cycle_length: int) -&gt; None</dt><dd><tt>print&nbsp;three&nbsp;ints<br>
writer&nbsp;a&nbsp;writer<br>
i&nbsp;the&nbsp;beginning&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
j&nbsp;the&nbsp;end&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;of&nbsp;the&nbsp;range,&nbsp;inclusive<br>
cycle_length&nbsp;the&nbsp;max&nbsp;cycle&nbsp;length</tt></dd></dl>
 <dl><dt><a name="-collatz_read"><strong>collatz_read</strong></a>(read_in: str) -&gt; List[int]</dt><dd><tt>read&nbsp;two&nbsp;ints<br>
read_in&nbsp;a&nbsp;string<br>
return&nbsp;a&nbsp;list&nbsp;of&nbsp;two&nbsp;ints,&nbsp;representing&nbsp;the&nbsp;beginning&nbsp;and&nbsp;end&nbsp;of&nbsp;a&nbsp;range,&nbsp;[i,&nbsp;j]</tt></dd></dl>
 <dl><dt><a name="-collatz_solve"><strong>collatz_solve</strong></a>(reader: IO[str], writer: IO[str]) -&gt; None</dt><dd><tt>reader&nbsp;a&nbsp;reader<br>
writer&nbsp;a&nbsp;writer</tt></dd></dl>
 <dl><dt><a name="-compute_cycle_length"><strong>compute_cycle_length</strong></a>(num: int) -&gt; int</dt><dd><tt>num&nbsp;an&nbsp;int&nbsp;greater&nbsp;than&nbsp;0<br>
cycle_length&nbsp;an&nbsp;int&nbsp;representing&nbsp;the&nbsp;number&nbsp;of&nbsp;steps&nbsp;so&nbsp;far<br>
Recursively&nbsp;computes&nbsp;the&nbsp;cycle&nbsp;length&nbsp;of&nbsp;the&nbsp;given&nbsp;input&nbsp;num<br>
If&nbsp;num&nbsp;is&nbsp;even,&nbsp;then&nbsp;let&nbsp;num&nbsp;=&nbsp;num&nbsp;/&nbsp;2<br>
If&nbsp;num&nbsp;is&nbsp;odd,&nbsp;then&nbsp;let&nbsp;num&nbsp;=&nbsp;3num&nbsp;+&nbsp;1<br>
Because&nbsp;3num&nbsp;+&nbsp;1&nbsp;produces&nbsp;an&nbsp;even&nbsp;number,&nbsp;we&nbsp;use&nbsp;a&nbsp;shortcut&nbsp;to&nbsp;skip&nbsp;a&nbsp;step<br>
(3num&nbsp;+&nbsp;1)&nbsp;/&nbsp;2&nbsp;=&nbsp;num&nbsp;+&nbsp;(num&nbsp;&gt;&gt;&nbsp;1)&nbsp;+&nbsp;1<br>
Cache&nbsp;computed&nbsp;values&nbsp;of&nbsp;any&nbsp;num&nbsp;that&nbsp;we&nbsp;encounter<br>
If&nbsp;num's&nbsp;cycle&nbsp;length&nbsp;has&nbsp;already&nbsp;been&nbsp;cached,&nbsp;use&nbsp;cache's&nbsp;value&nbsp;instead</tt></dd></dl>
 <dl><dt><a name="-compute_max_cycle_length"><strong>compute_max_cycle_length</strong></a>(start: int, end: int) -&gt; int</dt><dd><tt>max_cycle_length&nbsp;an&nbsp;int&nbsp;representing&nbsp;the&nbsp;max&nbsp;cycle&nbsp;length&nbsp;of&nbsp;the&nbsp;range<br>
Computes&nbsp;the&nbsp;max&nbsp;cycle&nbsp;length&nbsp;in&nbsp;a&nbsp;given&nbsp;range&nbsp;[start,&nbsp;end],&nbsp;inclusive</tt></dd></dl>
 <dl><dt><a name="-meta_cache_max_cycle_length"><strong>meta_cache_max_cycle_length</strong></a>(start: int, end: int) -&gt; int</dt><dd><tt>meta_cache_start&nbsp;starting&nbsp;index&nbsp;of&nbsp;closest&nbsp;interval&nbsp;greater&nbsp;than&nbsp;start<br>
meta_cache_end&nbsp;ending&nbsp;index&nbsp;of&nbsp;closest&nbsp;interval&nbsp;less&nbsp;than&nbsp;end<br>
Uses&nbsp;precomputed&nbsp;values&nbsp;in&nbsp;meta&nbsp;cache&nbsp;to&nbsp;find&nbsp;max&nbsp;cycle&nbsp;length<br>
Based&nbsp;on&nbsp;intervals&nbsp;of&nbsp;1,000&nbsp;numbers&nbsp;within&nbsp;the&nbsp;given&nbsp;range</tt></dd></dl>
</td></tr></table><p>
<table width="100%" cellspacing=0 cellpadding=2 border=0 summary="section">
<tr bgcolor="#55aa55">
<td colspan=3 valign=bottom>&nbsp;<br>
<font color="#ffffff" face="helvetica, arial"><big><strong>Data</strong></big></font></td></tr>
    
<tr><td bgcolor="#55aa55"><tt>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</tt></td><td>&nbsp;</td>
<td width="100%"><strong>CACHE</strong> = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...]<br>
<strong>CACHE_SIZE</strong> = 1000001<br>
<strong>List</strong> = typing.List<br>
<strong>META_CACHE</strong> = [179, 182, 217, 238, 215, 236, 262, 252, 247, 260, 268, 250, 263, 276, 271, 271, 266, 279, 261, 274, ...]</td></tr></table>
</body></html>